#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Treasure.ico
#AutoIt3Wrapper_Res_Fileversion=1.0.0.2
#AutoIt3Wrapper_Res_FileVersion_AutoIncrement=y
#AutoIt3Wrapper_Run_Tidy=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; Item Parse 1.0 By Guy Parisi
; Email: guyparisi@hotmail.com
; ENWorld: Guyanthalas

#include <File.au3>
#include <Array.au3>
Dim $ParseFile
Dim $LineCount
Dim $WriteCount
Dim $CurrentLine
Dim $OutputFile
Dim $ParseLine
Dim $Type
Dim $Level
Dim $Name
Dim $Bonus
Dim $Gold
Dim $FullName
Dim $Source

Global $NameArray[1]
Global $SourceArray[1]
Global $PageArray[1]
Global $CategoryArray[1]
Dim $Position

$LineCount = 0
$ParseFile = FileOpenDialog("File to Parse:", "@MyDocumentsDir", "Text Files (*.txt)", 1)
If @error Then Exit
$OutputFile = FileSaveDialog("Save as:", @WorkingDir, "XML Files (*.xml)", 16, "Output.xml")
If @error Then Exit
$LineCount = _FileCountLines($ParseFile)
$CurrentLine = 0
$Type = InputBox("Item Type?", "What type is this list? (Armor, Weapon, Neck, Ect...)")
$Source = InputBox("Source Material?", "Where book is this list from?")
Do
	$CurrentLine = $CurrentLine + 1
	$ParseLine = FileReadLine($ParseFile, $CurrentLine)
	If $ParseLine = "Lvl Name Price (gp)" Then ContinueLoop
	$Level = StringRegExp($ParseLine, '([0-9]{1,3})', 1)
	$Name = StringRegExp($ParseLine, '(?:\d)(?: )([A-z ]*)(?: +| \d)', 1)
	$Position = _ArraySearch($NameArray, $Name[0])
	If @error == 6 Then
		$Position = _ArrayAdd($NameArray, $Name[0])
		_ArrayAdd($PageArray, InputBox("Page Number?", "What page number is " & $Name[0] & " on?"))
		_ArrayAdd($CategoryArray, InputBox("Category Number?", "What category is " & $Name[0] & "?"))
	EndIf

	$Bonus = StringRegExp($ParseLine, '(?:[\+])([\d])', 1)
	If @error == 0 Then
		$FullName = $Name[0] & " +" & $Bonus[0]
	Else
		$Bonus = ""
		$FullName = $Name[0]
	EndIf

	$Gold = StringRegExp($ParseLine, '(?: )([0-9\,]{1,20})', 1)

	;Write the XML File
	FileWriteLine($OutputFile, @TAB & "<item itemName=" & Chr(34) & $FullName & Chr(34) & ">")
	FileWriteLine($OutputFile, @TAB & @TAB & "<Level>" & $Level & "</Level>")
	FileWriteLine($OutputFile, @TAB & @TAB & "<Type>" & $Type & "</Type>")
	FileWriteLine($OutputFile, @TAB & @TAB & "<CategoryNum>" & $CategoryArray[$Position] & "</CategoryNum>")
	FileWriteLine($OutputFile, @TAB & @TAB & "<Source>" & $Source & "</Source>")
	FileWriteLine($OutputFile, @TAB & @TAB & "<Page>" & $PageArray[$Position] & "</Page>")
	FileWriteLine($OutputFile, @TAB & "</item>")
Until $CurrentLine = $LineCount
FileWriteLine($OutputFile, @CR)


FileClose($ParseFile)
FileClose($OutputFile)
MsgBox(0, "Mischief Managed!", "File Parsing Complete!")